//----------------------------------------------------------------------------
// SLGgraph.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: SLGgraph.pas
//----------------------------------------------------------------------------
#ifndef SLGgraphHPP
#define SLGgraphHPP
//----------------------------------------------------------------------------
#include <Printers.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Slggraph
{
//-- type declarations -------------------------------------------------------
enum TStretchOption { StretchOnly, ShrinkOnly, Yes, No };

enum TZButton { MouseLeft, MouseRight, MouseMiddle };

enum TZKey { None, Shift, Ctrl, Alt, ShiftAlt, CtrlAlt, CtrlShift };

enum TAnnotationAngle { Horizontal, Vertical };

enum TLineMode { Graph, Windows };

enum TPlotDestination { ScreenOnly, PrinterOnly, Both };

class __declspec(delphiclass) TZoomBox;
class __declspec(pascalimplementation) TZoomBox : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FSaveStatus;
	bool FAutoErase;
	bool FBoxErased;
	TZButton FButton;
	TZKey FKey;
	Classes::TShiftState FState;
	bool FEnabled;
	Graphics::TColor FColor;
	float FScaledLeft;
	float FScaledRight;
	float FScaledTop;
	float FSecondScaledTop;
	float FScaledBottom;
	float FSecondScaledBottom;
	int FLeft;
	int FRight;
	int FTop;
	int FBottom;
	int FXStart;
	int FYStart;
	int FXSave;
	int FYSave;
	bool FZooming;
	float FXStartScaled;
	float FYStartScaled;
	float FYStart2Scaled;
	bool FValidZoom;
	void __fastcall SetButton(TZButton Value);
	void __fastcall SetKey(TZKey Value);
	void __fastcall BuildShiftState(void);
	
protected:
	__property Classes::TShiftState State = {read=FState, nodefault};
	
public:
	__fastcall TZoomBox(void);
	
__published:
	__property bool AutoErase = {read=FAutoErase, write=FAutoErase, nodefault};
	__property bool Enabled = {read=FEnabled, write=FEnabled, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property bool ValidZoom = {read=FValidZoom, nodefault};
	__property TZButton ZoomButton = {read=FButton, write=SetButton, nodefault};
	__property TZKey ZoomKey = {read=FKey, write=SetKey, nodefault};
	__property float XScaledLeft = {read=FScaledLeft, nodefault};
	__property float XScaledRight = {read=FScaledRight, nodefault};
	__property float YScaledTop = {read=FScaledTop, nodefault};
	__property float SecondYScaledTop = {read=FSecondScaledTop, nodefault};
	__property float YScaledBottom = {read=FScaledBottom, nodefault};
	__property float SecondYScaledBottom = {read=FSecondScaledBottom, nodefault};
	__property int Left = {read=FLeft, nodefault};
	__property int Right = {read=FRight, nodefault};
	__property int Top = {read=FTop, nodefault};
	__property int Bottom = {read=FBottom, nodefault};
public:
	/* TObject.Destroy */ __fastcall virtual ~TZoomBox(void) { }
	
};

class __declspec(delphiclass) TAxis;
class __declspec(pascalimplementation) TAxis : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TNotifyEvent FOnChange;
	bool FAxisMatchesFont;
	Graphics::TFont* FFont;
	System::AnsiString FAxisLabel;
	bool FLog;
	double FOrgVal;
	double FScale;
	int FNdivs;
	int FDivWidth;
	int FNFixed;
	int FNdecs;
	int FMinExponent;
	int FTicLength;
	int FNumberOffset;
	int FLabelOffset;
	TAnnotationAngle FAnnotationAngle;
	void __fastcall SetNumberOffset(int Value);
	void __fastcall SetLabelOffset(int Value);
	void __fastcall SetAxisLabel( System::AnsiString Value);
	void __fastcall SetOrgVal(double Value);
	void __fastcall SetScale(double Value);
	void __fastcall SetNdivs(int Value);
	void __fastcall SetDivWidth(int Value);
	void __fastcall SetNdecs(int Value);
	void __fastcall SetLog(bool Value);
	void __fastcall SetMinExponent(int Value);
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall Change(System::TObject* Sender);
	void __fastcall SetTicLength(int Value);
	void __fastcall SetNfixed(int Value);
	void __fastcall SetAxisMatchesFont(bool Value);
	void __fastcall SetAnnotationAngle(TAnnotationAngle Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall ReadAxisLabel(Classes::TReader* Reader);
	void __fastcall WriteAxisLabel(Classes::TWriter* Writer);
	
public:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__fastcall TAxis(void);
	__fastcall virtual ~TAxis(void);
	
__published:
	__property bool AxisMatchesFont = {read=FAxisMatchesFont, write=SetAxisMatchesFont, default=0};
	__property TAnnotationAngle AnnotationAngle = {read=FAnnotationAngle, write=SetAnnotationAngle, nodefault
		};
	__property int DivisionWidth = {read=FDivWidth, write=SetDivWidth, default=64};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont, nodefault};
	__property int AxisLabelOffset = {read=FLabelOffset, write=SetLabelOffset, default=10};
	__property bool LogAxis = {read=FLog, write=SetLog, default=0};
	__property int MinExponent = {read=FMinExponent, write=SetMinExponent, default=0};
	__property int NumberOfDecimals = {read=FNdecs, write=SetNdecs, default=1};
	__property int NumberOfDivisions = {read=FNdivs, write=SetNdivs, default=3};
	__property int NumberOfFixed = {read=FNFixed, write=SetNfixed, default=3};
	__property int NumberOffset = {read=FNumberOffset, write=SetNumberOffset, default=5};
	__property double OriginValue = {read=FOrgVal, write=SetOrgVal};
	__property double ScalePerDivision = {read=FScale, write=SetScale};
	__property int TicLength = {read=FTicLength, write=SetTicLength, default=5};
	__property System::AnsiString AxisLabel = {read=FAxisLabel, write=SetAxisLabel, stored=false, nodefault
		};
};

class __declspec(delphiclass) TSLGgraph;
class __declspec(pascalimplementation) TSLGgraph : public Controls::TGraphicControl
{
	typedef Controls::TGraphicControl inherited;
	
private:
	int TestWidth;
	int TestHeight;
	int PixsPerInch;
	int TitleFontSize;
	int SubTitleFontSize;
	int IdFontSize;
	int XAxisFontSize;
	int YAxisFontSize;
	int YAxis2FontSize;
	double Ln10;
	int PrintWidth;
	int PrintHeight;
	HRGN ClipRegion1;
	HRGN ClipRegion2;
	HRGN ClipRegion3;
	float x;
	float y;
	Graphics::TBitmap* ThePlot;
	bool Designing;
	bool ClearFlag;
	float FontScale;
	float LogValues[9];
	int FPrinterXorg;
	int FPrinterYorg;
	int FPrinterXend;
	int FPrinterYend;
	int Xcent;
	int Ycent;
	int Xlength;
	int Ylength;
	int Xloc;
	int Yloc;
	int Xplot;
	int Yplot;
	int BitmapXplot;
	int BitmapYplot;
	int TopHeight;
	int BottomHeight;
	int LeftWidth;
	int RightWidth;
	int XdivWidth;
	int YdivWidth;
	TPenMode SavePenMode;
	int SavePenWidth;
	Graphics::TColor SavePenColor;
	TPenStyle SavePenStyle;
	TStretchOption FStretchAxes;
	TPlotDestination FDestination;
	bool FPrintFlag;
	bool FAutoSize;
	int FLRmargin;
	int FXCanvas;
	int FYCanvas;
	int FTBmargin;
	int FPrinterPenWidth;
	float FScaleFactor;
	Classes::TNotifyEvent FOnChange;
	System::AnsiString FTitle;
	int FTitleOffset;
	Graphics::TFont* FTitleFont;
	System::AnsiString FSubtitle;
	Graphics::TFont* FSubtitleFont;
	int FSubtitleOffset;
	System::AnsiString FIdentification;
	Graphics::TFont* FIdentificationFont;
	int FIdentificationOffset;
	bool FBorder;
	TAxis* FXaxis;
	int FXorg;
	int FYorg;
	int FXend;
	int FYend;
	TAxis* FYaxis;
	TAxis* FYaxis2;
	bool FSecondYaxis;
	bool FUseSecondYAxis;
	TLineMode FLineMode;
	bool FMajorGrid;
	bool FMinorGrid;
	int FMinorGridDivisions;
	Graphics::TColor FMajorGridColor;
	Graphics::TColor FMinorGridColor;
	Graphics::TColor FAreaBackGroundColor;
	Graphics::TColor FPlotBackGroundColor;
	Graphics::TColor FPlotColor;
	TPenMode FPenMode;
	TPenStyle FPenStyle;
	bool FScreenFlag;
	int FPenWidth;
	float FPrintedWidth;
	float FPrintedHeight;
	int FPrinterXcanvas;
	int FPrinterYcanvas;
	int FPrinterLeft;
	int FPrinterTop;
	bool FPrintMonochrome;
	int FPrinterMajorGridWidth;
	int FPrinterMinorGridWidth;
	int FPrinterPixelsPerInch;
	Graphics::TColor FHighlightColor;
	Graphics::TColor FShadowColor;
	bool FClipData;
	int FXGraph;
	int FYGraph;
	int FPrinterXGraph;
	int FPrinterYGraph;
	TZoomBox* FZoomBox;
	bool FEraseFlag;
	void __fastcall SetTitle( System::AnsiString Value);
	void __fastcall SetSubtitle( System::AnsiString Value);
	void __fastcall SetIdentification( System::AnsiString Value);
	void __fastcall SetBorder(bool Value);
	void __fastcall SetSecondYaxis(bool Value);
	void __fastcall SetMajorGrid(bool Value);
	void __fastcall SetMinorGrid(bool Value);
	void __fastcall SetMinorGridDivisions(int Value);
	void __fastcall SetMajorGridColor(Graphics::TColor Value);
	void __fastcall SetMinorGridColor(Graphics::TColor Value);
	void __fastcall SetAreaBackGroundColor(Graphics::TColor Value);
	void __fastcall SetPlotBackGroundColor(Graphics::TColor Value);
	void __fastcall SetPlotColor(Graphics::TColor Value);
	void __fastcall SetPlotDestination(TPlotDestination Value);
	void __fastcall SetHighlightColor(Graphics::TColor Value);
	void __fastcall SetShadowColor(Graphics::TColor Value);
	void __fastcall SetPenWidth(int Value);
	void __fastcall SetPenMode(Graphics::TPenMode Value);
	void __fastcall SetPenStyle(Graphics::TPenStyle Value);
	void __fastcall SetTitleFont(Graphics::TFont* Value);
	void __fastcall SetSubtitleFont(Graphics::TFont* Value);
	void __fastcall SetIdentificationFont(Graphics::TFont* Value);
	void __fastcall SetTitleOffset(int Value);
	void __fastcall SetSubtitleOffset(int Value);
	void __fastcall SetIdOffset(int Value);
	void __fastcall Redraw(System::TObject* Sender);
	void __fastcall Clear(void);
	void __fastcall Change(System::TObject* Sender);
	void __fastcall DrawGrids(void);
	void __fastcall DrawPrinterGrids(float FScaleFactor);
	void __fastcall DrawXAxis(Graphics::TCanvas* Surface, int Xorg, int Yorg, bool Printing);
	void __fastcall DrawYAxis(Graphics::TCanvas* Surface, int Xorg, int Yorg, bool Printing);
	void __fastcall DrawYAxis2(Graphics::TCanvas* Surface, int Xend, int Yorg, bool Printing);
	void __fastcall Inval(System::TObject* Sender);
	void __fastcall AutoScale(float &Min, float &Max, int Divs);
	void __fastcall AdjustAxes(void);
	bool __fastcall DelphiIsRunning(void);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall ReadTitle(Classes::TReader* Reader);
	void __fastcall WriteTitle(Classes::TWriter* Writer);
	void __fastcall ReadSubtitle(Classes::TReader* Reader);
	void __fastcall WriteSubtitle(Classes::TWriter* Writer);
	void __fastcall ReadId(Classes::TReader* Reader);
	void __fastcall WriteId(Classes::TWriter* Writer);
	void __fastcall SetAutoSize(bool Value);
	void __fastcall SetLRmargin(int Value);
	void __fastcall SetTBmargin(int Value);
	
public:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__fastcall virtual TSLGgraph(Classes::TComponent* Aowner);
	__fastcall virtual ~TSLGgraph(void);
	__property Graphics::TBitmap* PersistentBitmap = {read=ThePlot, write=ThePlot, nodefault};
	
__published:
	bool __fastcall CursorInPlotArea(int X, int Y);
	void __fastcall PlotLastPixel(void);
	void __fastcall EraseZoomBox(void);
	void __fastcall NoPrinterClipping(void);
	void __fastcall GetValues(int X, int Y, float &XPlot, float &YPlot, int &XPixels, int &YPixels);
	void __fastcall SaveToFile( System::AnsiString FileName);
	void __fastcall SaveCanvas(void);
	HIDESBASE void __fastcall Refresh(void);
	void __fastcall PrintGrids(float X, float Y, float Size);
	void __fastcall SetAxis(TAxis* Axis, float Org, float Scale, int Ndivs, bool AutoScl);
	void __fastcall LineScaledTo(float x, float y);
	void __fastcall MoveScaledTo(float x, float y);
	void __fastcall MoveTo(int x, int y);
	void __fastcall LineTo(int x, int y);
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=1};
	__property bool Border = {read=FBorder, write=SetBorder, default=1};
	__property bool ClipData = {read=FClipData, write=FClipData, default=1};
	__property Canvas ;
	__property Graphics::TColor Color = {read=FAreaBackGroundColor, write=SetAreaBackGroundColor, default=-2147483633
		};
	__property Height ;
	__property Graphics::TColor HighlightColor = {read=FHighlightColor, write=SetHighlightColor, default=16777215
		};
	__property int IdOffset = {read=FIdentificationOffset, write=SetIdOffset, default=5};
	__property Graphics::TFont* IdFont = {read=FIdentificationFont, write=SetIdentificationFont, nodefault
		};
	__property TLineMode LineMode = {read=FLineMode, write=FLineMode, default=0};
	__property int LRmargin = {read=FLRmargin, write=SetLRmargin, default=10};
	__property bool MajorGrid = {read=FMajorGrid, write=SetMajorGrid, default=1};
	__property Graphics::TColor MajorGridColor = {read=FMajorGridColor, write=SetMajorGridColor, default=0
		};
	__property bool MinorGrid = {read=FMinorGrid, write=SetMinorGrid, default=1};
	__property Graphics::TColor MinorGridColor = {read=FMinorGridColor, write=SetMinorGridColor, default=12632256
		};
	__property int MinorGridDivisions = {read=FMinorGridDivisions, write=SetMinorGridDivisions, default=4
		};
	__property int PenWidth = {read=FPenWidth, write=SetPenWidth, default=1};
	__property Graphics::TColor PenColor = {read=FPlotColor, write=SetPlotColor, default=0};
	__property Graphics::TPenMode PenMode = {read=FPenMode, write=SetPenMode, default=4};
	__property Graphics::TPenStyle PenStyle = {read=FPenStyle, write=SetPenStyle, nodefault};
	__property Graphics::TColor PlotAreaColor = {read=FPlotBackGroundColor, write=SetPlotBackGroundColor
		, default=16777215};
	__property TPlotDestination PlotDestination = {read=FDestination, write=SetPlotDestination, default=0
		};
	__property float PrintedHeight = {read=FPrintedHeight, nodefault};
	__property float PrintedWidth = {read=FPrintedWidth, nodefault};
	__property bool PrinterEnabled = {read=FPrintFlag, write=FPrintFlag, default=0};
	__property int PrinterLeft = {read=FPrinterLeft, nodefault};
	__property int PrinterMajorGridWidth = {read=FPrinterMajorGridWidth, write=FPrinterMajorGridWidth, 
		default=3};
	__property int PrinterMinorGridWidth = {read=FPrinterMinorGridWidth, write=FPrinterMinorGridWidth, 
		default=1};
	__property int PrinterPenWidth = {read=FPrinterPenWidth, write=FPrinterPenWidth, nodefault};
	__property int PrinterPixelsPerInch = {read=FPrinterPixelsPerInch, nodefault};
	__property float PrinterScaleFactor = {read=FScaleFactor, nodefault};
	__property int PrinterTop = {read=FPrinterTop, nodefault};
	__property int PrinterXcanvas = {read=FPrinterXcanvas, nodefault};
	__property int PrinterYcanvas = {read=FPrinterYcanvas, nodefault};
	__property int PrinterXend = {read=FPrinterXend, nodefault};
	__property int PrinterYend = {read=FPrinterYend, nodefault};
	__property int PrinterXGraph = {read=FPrinterXGraph, nodefault};
	__property int PrinterYGraph = {read=FPrinterYGraph, nodefault};
	__property int PrinterXorigin = {read=FPrinterXorg, nodefault};
	__property int PrinterYorigin = {read=FPrinterYorg, nodefault};
	__property bool PrintMonoChrome = {read=FPrintMonochrome, write=FPrintMonochrome, default=0};
	__property bool SecondYaxis = {read=FSecondYaxis, write=SetSecondYaxis, default=0};
	__property bool ScreenEnabled = {read=FScreenFlag, write=FScreenFlag, default=1};
	__property Graphics::TColor ShadowColor = {read=FShadowColor, write=SetShadowColor, default=8421504
		};
	__property TStretchOption StretchAxes = {read=FStretchAxes, write=FStretchAxes, default=3};
	__property Graphics::TFont* SubtitleFont = {read=FSubtitleFont, write=SetSubtitleFont, nodefault};
	__property int SubtitleOffset = {read=FSubtitleOffset, write=SetSubtitleOffset, default=5};
	__property int TBmargin = {read=FTBmargin, write=SetTBmargin, default=10};
	__property System::AnsiString Title = {read=FTitle, write=SetTitle, stored=false, nodefault};
	__property System::AnsiString Subtitle = {read=FSubtitle, write=SetSubtitle, stored=false, nodefault
		};
	__property System::AnsiString Id = {read=FIdentification, write=SetIdentification, stored=false, nodefault
		};
	__property Graphics::TFont* TitleFont = {read=FTitleFont, write=SetTitleFont, nodefault};
	__property int TitleOffset = {read=FTitleOffset, write=SetTitleOffset, default=5};
	__property bool UseSecondYAxis = {read=FUseSecondYAxis, write=FUseSecondYAxis, default=0};
	__property Visible ;
	__property Width ;
	__property TAxis* XAxis = {read=FXaxis, write=FXaxis, nodefault};
	__property int XCanvas = {read=FXCanvas, nodefault};
	__property int YCanvas = {read=FYCanvas, nodefault};
	__property int Xend = {read=FXend, nodefault};
	__property int XGraph = {read=FXGraph, nodefault};
	__property int Yend = {read=FYend, nodefault};
	__property int YGraph = {read=FYGraph, nodefault};
	__property int Xorigin = {read=FXorg, nodefault};
	__property int Yorigin = {read=FYorg, nodefault};
	__property TAxis* YAxis = {read=FYaxis, write=FYaxis, nodefault};
	__property TAxis* YAxis2 = {read=FYaxis2, write=FYaxis2, nodefault};
	__property TZoomBox* ZoomBox = {read=FZoomBox, write=FZoomBox, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class Classes::TShiftState ;

}	/* namespace Slggraph */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Slggraph;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SLGgraph
